﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IEProxyManagment
{
    public partial class ProxySetingWin : Form
    {
        public ProxySetingWin()
        {
            InitializeComponent();
        }

        private void btnSetProxy_Click(object sender, EventArgs e)
        {
            string proxyStr = combProxyList.Text.Trim();
            IEProxySetting.SetProxy(proxyStr, null);
            var currentProxy = GetProxyServer();
            if (currentProxy == proxyStr && GetProxyStatus())
            {
                lblInfo.Text = "设置代理：" + proxyStr + "成功！";
                lblInfo.ForeColor = Color.Green;
            }
            else
            {
                if (!GetProxyStatus())
                {
                    lblInfo.Text = "设置代理：" + proxyStr + "代理未启用！";

                }
                else
                {
                    lblInfo.Text = "设置代理：" + proxyStr + "失败，正在使用" + currentProxy + "代理，请重试！";

                }
                lblInfo.ForeColor = Color.Red;
            }
            ShowProxyInfo();
        }

        private void ProxySetingWin_Load(object sender, EventArgs e)
        {
            ShowProxyInfo();
            InitProxyData();
        }

        /// <summary>
        /// 获取正在使用的代理
        /// </summary>
        /// <returns></returns>
        private string GetProxyServer()
        {
            //打开注册表 
            RegistryKey regKey = Registry.CurrentUser;
            string SubKeyPath = "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings";
            RegistryKey optionKey = regKey.OpenSubKey(SubKeyPath, true);             //更改健值，设置代理， 
            string actualProxy = optionKey.GetValue("ProxyServer").ToString();
            regKey.Close();
            return actualProxy;
        }

        private bool GetProxyStatus()
        {
            //打开注册表 
            RegistryKey regKey = Registry.CurrentUser;
            string SubKeyPath = "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings";
            RegistryKey optionKey = regKey.OpenSubKey(SubKeyPath, true);             //更改健值，设置代理， 
            int actualProxyStatus = Convert.ToInt32(optionKey.GetValue("ProxyEnable"));
            regKey.Close();
            return actualProxyStatus == 1 ? true : false;
        }

        private void ShowProxyInfo()
        {
            if (!GetProxyStatus())
            {
                lblInitInfo.Text = "代理未启用：";
            }
            else
            {
                lblInitInfo.Text = "当前使用的代理是：" + GetProxyServer();
            }
        }

        private void InitProxyData()
        {
            List<string> proxyList = new List<string>{
               "http://web-proxy.cup.hp.com:8080","http://proxy.compaq.com:8080"
           };
            combProxyList.DataSource = proxyList;
            combProxyList.SelectedIndex = 0;
        }

        private void btnDisableProxy_Click(object sender, EventArgs e)
        {
            if (IEProxySetting.UnsetProxy())
            {
                MessageBox.Show("取消完成！");
            }
            else
            {
                MessageBox.Show("取消失败！");
            }

            if (!GetProxyStatus())
            {
                lblInfo.Text = "取消代理完成！";
                lblInfo.ForeColor = Color.Green;
            }
            else
            {
                lblInfo.Text = "取消失败，正在使用代理" + GetProxyServer();
                lblInfo.ForeColor = Color.Red;
            }
            ShowProxyInfo();
        }
    }
}
